#include "triangleApp.h"



triangleApp::triangleApp(){
	
	
}


void triangleApp::init(){

	
	IT  = new imageTexture(1024, 1024, GL_RGB);    //big enough for 1024 by 768
												  //FOR LARGER Resolutions use 2048 by 2048				
									
												  //VIDEO INPUT 								
												  				
	videoInput::listDevices();					  //optional static function to list devices
		
	VI  = new videoInput();						  //class to manage all the cameras
	VI  ->setPhyCon(0, VI_COMPOSITE);			  //optional (CAPTURE DEVICE TO SETUP, CAPTURE_CONNECTION) - use VI_COMPOSITE (defualt) for most
	
	//CHANGE SETTINGS IN GLOBAL_DEFS.h
	VI  ->setCaptureSize(0,CAM_W,CAM_H);		  //optional (CAPTURE DEVICE TO SETUP, CAPTURE WIDTH, CAPTURE HEIGHT)
	
	VI  ->setup(0);  							  //required (CAPTURE DEVICE TO SETUP) - 0 is the first device

	frame   = new unsigned char[VI->getSize(0)];  //optional (DEVICE NUMBER) - gets the buffer size of the image handed back

}

void triangleApp::idle(){
	
	if(VI->grabFrame(0, frame))					  //required (DEVICE NUMBER, BUFFER BIG ENOUGH FOR IMAGE) - returns rgb image as a byte array
	{
		IT->loadImageData(frame, VI->getWidth(0), VI->getHeight(0), GL_RGB); //use VI->width etc so that you don't get a crash
	}	

}




void triangleApp::draw(){
  
	setupScreen();
	IT->renderTexture(0, 0, VI->getWidth(0), VI->getHeight(0));
}

void triangleApp::keyDown  (char c){

	if(c=='S')
	{
		VI->showSettingsWindow(0);
	}

}

void triangleApp::mouseMove( float x, float y ){


}

void triangleApp::mouseDrag( float x, float y ){

}

void triangleApp::mouseDown( float x, float y, int button ){

}

void triangleApp::mouseUp  ( float x, float y, int button ){

}


